<?php
/**
 * Esta clase tiene la única misión de crear la tabla
 * de las migraciones.
 *
 * @package PAR::Migration
 * @author Manuel A. Rubio
 * @license GPL
 */
class PAR_Migration_Base extends PAR_Base {
	
	protected static $idx = "migrations";
	protected static $table = "migrations";
	protected static $class = __CLASS__;
	
	protected static $quote = array (
		"id" => false,
		"version" => false
	);
	
	/**
	 * Crea la tabla de la base de datos, si no existe.
	 */
	public static function createIfNotExists() {
		try {
			$tabla = new PAR_Migration_Table(self::$idx, self::$table, null, PAR_Migration_Table::ACTION_NEW);
			$tabla
				->add_column("version", "integer")
			->run();
		} catch (Exception $e) {
			// FIXME: crear un tipo de excepción específico para que no sea tan general.
		}
	}
	
	public static function getLastVersion() {
		$last = self::max("version");
		return (!$last) ? 0 : $last;
	}
	
}
